using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Remoting.Channels.Http;

using RemotingServerDemo;

namespace RemotingClientDemo
{
	class MainClass
	{
		static void Main(string[] args)
		{
			//   TcpChannel  HttpChannel      
			ChannelServices.RegisterChannel(new TcpChannel());

			//       ,      new
			//        RemotingConfiguration.Configure()    
			RemotingConfiguration.RegisterWellKnownClientType(typeof(Speaker), "tcp://localhost:3333/ServerSpeaker");
//			RemotingConfiguration.RegisterActivatedClientType(typeof(Speaker), "tcp://localhost:3333/");

			//    GetObject,  ,   server-side activation ;
			//  RegisterWellKnownClientType,  -,  
			Speaker speaker = new Speaker(); //(Speaker)Activator.GetObject(typeof(Speaker), "tcp://localhost:3333/ServerSpeaker");

			Console.WriteLine(speaker.SaySomething("Client 1"));
			Console.WriteLine(speaker.SaySomething("Client 1"));
			Console.WriteLine(speaker.SaySomething("Client 1"));

			//    GetObject,  ,   server-side activation ;
			//  RegisterWellKnownClientType,  -,  
			Speaker speaker2 = new Speaker(); //(Speaker)Activator.GetObject(typeof(Speaker), "tcp://localhost:3333/ServerSpeaker");

			Console.WriteLine(speaker2.SaySomething("Client 1"));
			Console.WriteLine(speaker2.SaySomething("Client 1"));
			Console.WriteLine(speaker2.SaySomething("Client 1"));
		}
	}
}
