using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Remoting.Channels.Http;

namespace RemotingServerDemo
{
	class MainClass
	{
		static void Main(string[] args)
		{
			//      ;
			//           
			ChannelServices.RegisterChannel(new TcpChannel(3333));
			ChannelServices.RegisterChannel(new HttpChannel(3334));

			//      RegisterWellKnownServiceType 
			// RegisterActivatedServerType       server-side
			//  client-side 

			//   SingleCall  Singleton          
			RemotingConfiguration.RegisterWellKnownServiceType(
				typeof(Speaker),
				"ServerSpeaker",
				WellKnownObjectMode.SingleCall);

//			RemotingConfiguration.RegisterActivatedServiceType(typeof(Speaker));

			Console.WriteLine("Press enter to stop the server...");
			Console.ReadLine();
		}
	}
}
