using System;

namespace RemotingServerDemo
{
	public class Speaker : MarshalByRefObject
	{
		private static int numberOfSpeakers = 0;
		private int speakerNumber;

		public Speaker()
		{
			speakerNumber = ++numberOfSpeakers;

			Console.WriteLine("[Speaker number {0} was created]", speakerNumber);
		}

		public string SaySomething(string clientName)
		{
			Console.WriteLine("[Speaker number {0} saying something to client {1}]", speakerNumber, clientName);

			return string.Format("Hello, {0}, speaker number {1} is saying something to you!", clientName, speakerNumber);
		}
	}
}
